from os.path import join

from battle import *
from extended_graphics import *
from unit import *
from script import *

class Player:
    def __init__(self):
        self.units = {}
        self.units["Justice"] = Justice()
        self.units["Law"]     = Law()
        self.units["Virtue"]  = Virtue()
        self.units["Wisdom"]  = Wisdom()

def run():
    player = Player()

    #First map
    background  = load_image(join("data", "images", "map_1.png"))
    grid = [
        "...##############...",
        ".....##########.....",
        "....................",
        "....................",
        "....................",
        "..........##........",
        "........####........",
        ".........##.........",
        ".....#..............",
        ".....#..............",
        ".....##.............",
        ".....##...........##",
        ".....####.........##",
        ".....#########...###",
        ".....###############"
    ]
    bg          = Battleground(background, grid)
    objectives  = "VICTORY\n  * Defeat all pirates.\n\nDEFEAT\n  * Justice is defeated."
    enemy_units = {}
    enemy_units["Pirate 1"] = Pirate("Pirate 1", 1, (17, 5))
    enemy_units["Pirate 2"] = Pirate("Pirate 2", 1, (4, 5))
    battle      = Battle(bg, player.units, enemy_units, objectives, Map1Script())
    battle.run()

