'''A few custom widgets for IP-Saints.'''

from os.path import join

from spg import gui
from spg.gui import *
from spg import defaultStyle

from extended_graphics import *

from pause import * # Hackish!
from quit  import * # Hacking! (x2)
from util  import * # Dude

selected_card = None

class FixedWindow(Window):
    '''A modified window widget that can't be moved around.'''
    def __init__(self,  position = None , size = (140,50), parent = None, style = None, text = " ", closeable = False, shadeable = False):
        Window.__init__(self,  position, size, parent, style, text, closeable, shadeable)

    def update(self, topmost):
        
        Container.update(self, topmost)
        Widget.update(self, topmost)
        
        if self.mousedown and self.enabled:
            self.parent.bringToFront(self)
#HORRIBLE LOOKING CODE STARTS HERE =( =( =(

class ChatWindow(FixedWindow):
    '''A very customized widget.'''
    def __init__(self, name, text, parent):
        style = gui.defaultWindowStyle.copy()
        style['font-color'] = (255, 255, 0)

        autowrap_label = gui.defaultLabelStyle.copy()
        autowrap_label['autosize'] = False
        autowrap_label['wordwrap'] = True

        Window.__init__(self,  (0, 442), (800, 158), parent, style, name, False, False)
        #TODO insert portrait
        Label(position = (148, 20), size = (642, 128), parent = self, text = text, style = autowrap_label)
        ok = Button(position = (740, 128), size = (50, 0), parent = self, text = "OK")
        ok.onClick = unpause

def alert(title, text):
    window_style = gui.defaultWindowStyle.copy()
    window_style['font-color'] = (255, 255, 0)

    autowrap_label = gui.defaultLabelStyle.copy()
    autowrap_label['autosize'] = False
    autowrap_label['wordwrap'] = True

    screen     = pygame.display.get_surface()
    background = screen.copy()
    clock      = pygame.time.Clock()

    desktop = gui.Desktop()
    window  = FixedWindow(position = (200,220), size = (400,200), parent = desktop, text = title, style=window_style)
    label   = gui.Label(position = (20, 20), size = (360, 140), parent = window, text = text, style=autowrap_label)
    button  = gui.Button(position = (340,170), size = (50,0), parent = window,  text = "OK")
    button.onClick = unpause

    pause()
    while paused() and not hasQuit():
        for e in gui.setEvents():
            if e.type == pygame.QUIT:
                postQuit()

        desktop.update()
        screen.blit(background, (0,0))
        desktop.draw()
        pygame.display.flip()
        clock.tick(60)

def speak(character, text):
    screen     = pygame.display.get_surface()
    background = screen.copy()
    clock      = pygame.time.Clock()

    desktop   = Desktop()
    window    = ChatWindow(character.name, text, desktop)
    window.ok = unpause

    pause()
    while paused() and not hasQuit():
        for e in gui.setEvents():
            if e.type == pygame.QUIT:
                postQuit()

        desktop.update()
        screen.blit(background, (0,0))
        desktop.draw()
        screen.blit(character.portrait, (10, 462))
        pygame.display.flip()
        clock.tick(60)

def showStatus(unit):
    screen     = pygame.display.get_surface()
    background = screen.copy()
    clock      = pygame.time.Clock()

    desktop  = Desktop()
    position = (200, 220)
    size     = (400, 168)
    window   = FixedWindow(position = position, size = size, parent = desktop, text = unit.name, closeable=True)
    window.onClose = unpause

    #Labels:
    Label(position = (148, 30), parent = window, text = "Level:")
    Label(position = (218, 30), parent = window, text = str(unit.stats["level"]))
    Label(position = (148, 50), parent = window, text = "Attack:")
    Label(position = (218, 50), parent = window, text = str(unit.stats["attack"]))
    Label(position = (148, 70), parent = window, text = "Defense:")
    Label(position = (218, 70), parent = window, text = str(unit.stats["defense"]))
    Label(position = (148, 90), parent = window, text = "Speed:")
    Label(position = (218, 90), parent = window, text = str(unit.stats["speed"]))

    if unit.player:
        Label(position = (280, 50), parent = window, text = "Law:")
        Label(position = (350, 50), parent = window, text = str(unit.stats["law"]))
        Label(position = (280, 70), parent = window, text = "Virtue:")
        Label(position = (350, 70), parent = window, text = str(unit.stats["virtue"]))
        Label(position = (280, 90), parent = window, text = "Wisdom:")
        Label(position = (350, 90), parent = window, text = str(unit.stats["wisdom"]))
    else:
        Label(position = (280, 50), parent = window, text = "Crime:")
        Label(position = (350, 50), parent = window, text = str(unit.stats["law"]))
        Label(position = (280, 70), parent = window, text = "Vice:")
        Label(position = (350, 70), parent = window, text = str(unit.stats["virtue"]))
        Label(position = (280, 90), parent = window, text = "Folly:")
        Label(position = (350, 90), parent = window, text = str(unit.stats["wisdom"]))

    Label(position = (148, 110), parent = window, text = "HP:")
    Label(position = (218, 110), parent = window, text = str(unit.stats["hp"]) + "/" + str(unit.stats["hp-max"]))
    Label(position = (148, 130), parent = window, text = "MP:")
    Label(position = (218, 130), parent = window, text = str(unit.stats["mp"]) + "/" + str(unit.stats["mp-max"]))

    pause()
    while paused() and not hasQuit():
        for e in gui.setEvents():
            if e.type == pygame.QUIT:
                postQuit()

        desktop.update()
        screen.blit(background, (0,0))
        desktop.draw()
        screen.blit(unit.portrait, (position[0]+10, position[1] + 30))
        pygame.display.flip()
        clock.tick(60)

def cardButtonAction(button):
    '''Call this function when you are unhappy with the code structure.'''
    global selected_card
    selected_card = button.cardValue
    unpause()


def cardSelect(cards, attack_card):
    global selected_card
    if len(cards) == 0:
        return None
    screen     = pygame.display.get_surface()
    background = screen.copy()
    clock      = pygame.time.Clock()

    desktop = Desktop()
    window  = FixedWindow(position = (185, 500), size = (430, 100), parent = desktop)
    xpos    = 10

    cardImages = load_image(join("data", "images", "card_images.png"))

    buttonStyle = createImageButtonStyle(load_image(join("data", "images", "card_button.png")), 60)
    for c in cards:
        button = ImageButton((xpos, 10), parent = window, style = buttonStyle)
        button.cardValue = c
        button.onClick = cardButtonAction
        xpos += 70

    pause()
    print cards
    while paused() and not hasQuit():
        for e in gui.setEvents():
            if e.type == pygame.QUIT:
                postQuit()

        desktop.update()
        screen.blit(background, (0,0))
        desktop.draw()
        xpos = 10 + 185
        for c in cards:
            frame_w = card_index(c) * 40
            screen.blit(cardImages, (xpos + 10, 530), ((frame_w, 0), (40, 40)))
            xpos += 70
            
        #Draw over the cards here
        #Draw the attack card here
        pygame.display.flip()
        clock.tick(60)

    return selected_card

#I don't care, it works. Kinda.

