import pygame

from spg import gui
from spg import defaultStyle
import gui_extras

from os.path import join

from extended_graphics import *
from quit              import *

import game

def new_game(button):
    fade_out()
    game.run()
    if not hasQuit():
        background = load_image(join("data", "images", "title_screen.png"))
        fade_in(background)

def load_game(button):
    fade_out()
    #load game
    if not hasQuit():
        background = load_image(join("data", "images", "title_screen.png"))
        fade_in(background)

def credits():
    pass

def run():
    screen = pygame.display.get_surface()
    clock  = pygame.time.Clock()
    desktop = gui.Desktop()
    window  = gui_extras.FixedWindow(position = (280, 280), size = (240, 180), parent = desktop)
    button1 = gui.Button(position = (20,20), size = (200,0), parent = window, text = "New game")
    button2 = gui.Button(position = (20,60), size = (200,0), parent = window, text = "Load game")
    button3 = gui.Button(position = (20,100), size = (200,0), parent = window, text = "Credits")
    button4 = gui.Button(position = (20,140), size = (200,0), parent = window, text = "Quit")
    button1.onClick = new_game
    button2.onClick = load_game
    button4.onClick = postQuit

    background = load_image(join("data", "images", "title_screen.png"))
    fade_in(background)

    while not hasQuit():
        for e in gui.setEvents():
            if e.type == pygame.QUIT:
                postQuit()

        desktop.update()        
        screen.blit(background, (0, 0))
        desktop.draw()
        if not hasQuit():
            pygame.display.flip()
            clock.tick(60)

